use std::{error::Error, fmt, fmt::Display};

#[derive(Debug, PartialEq)]
pub struct LexerError {
    message: String,
}

impl Display for LexerError {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{}", &self.message)
    }
}

impl Error for LexerError {}

// impl Into<std::io::Error> for LexerError {
//     fn into(self) -> std::io::Error {
//         std::io::Error::new(std::io::ErrorKind::InvalidInput, self.message)
//     }
// }

impl From<LexerError> for std::io::Error {
    fn from(e: LexerError) -> Self {
        Self::new(std::io::ErrorKind::InvalidInput, e.message)
    }
}
